///////////////////////////////////////////////////////////////////////////////
// AWRootWindow.uc
// Copyright 2003 Running With Scissors, Inc.  All Rights Reserved.
//
///////////////////////////////////////////////////////////////////////////////
class Ig50RootWindow extends AWRootWindow;

var const int KeyConfigVersion;
var config int AW7Version;
/*
///////////////////////////////////////////////////////////////////////////////
// Called after this object has been created
///////////////////////////////////////////////////////////////////////////////
event Initialized()
{
	Super.Initialized();

	if (AW7Version != KeyConfigVersion)
	{
		// Set up INI file on first INI creation.
		log(self@"initializing AW7 INI settings...");

		GetPlayerOwner().ConsoleCommand("set Engine DefaultGame AW7addinIG50Game.Ig50GameInfo");
		GetPlayerOwner().ConsoleCommand("set System SavePath ../Ig50Save");
		AW7Version = KeyConfigVersion;
		SaveConfig();

		GetPlayerOwner().Level.ServerTravel("?Game=AW7addinIG50Game.Ig50GameInfo", false);
	}
}
*/
///////////////////////////////////////////////////////////////////////////////
// Default properties
///////////////////////////////////////////////////////////////////////////////

defaultproperties
{
     KeyConfigVersion=100
     MenuMainClass=Class'AW7addinIG50Shell.Ig50MainMenu'
     MenuGameClass=Class'AW7addinIG50Shell.Ig50MenuGame'
     StartupMapName="AW7_Startup"
}
