class Ig50GameWeekend extends Ig50GameInfo;

function bool IsWeekend()
{
	return true;
}

defaultproperties
{
     Days(0)=DayBase'AW7addinIG50Game.DayBase8'
     Days(1)=DayBase'AW7addinIG50Game.DayBase9'
     Begin Object Class=DayBase Name=DayBase61
         Description="Wednesday"
         UniqueName="7DAYC"
         ExcludeDays(0)="DEMO"
         MapTex="p2misc_full.map_day3"
         NewsTex="p2misc_full.newspaper_day_3"
         DudeNewsComment="DudeDialog.dude_news_wednesday"
         LoadTex="p2misc_full.loading3"
         DudeStartComment="DudeDialog.dude_map_exit3"
         Errands(0)=ErrandBase'AW7Game.ErrandBase7'
         Errands(1)=ErrandBase'AW7Game.ErrandBase8'
         Errands(2)=ErrandBase'AW7Game.ErrandBase9'
         Errands(3)=ErrandBase'AW7Game.ErrandBase10'
         TakeFromPlayerList(0)=(InvClassName="Inventory.NewspaperInv")
         TakeFromPlayerList(1)=(InvClassName="Inventory.GimpClothesInv")
         TakeFromPlayerList(2)=(InvClassName="Inventory.DudeClothesInv")
         TakeFromPlayerList(3)=(InvClassName="Inventory.TreeInv")
         Name="DayBase61"
     End Object
     Days(2)=DayBase'AW7addinIG50Game.DayBase61'
     Begin Object Class=DayBase Name=DayBase62
         Description="Thursday"
         UniqueName="7DAYD"
         ExcludeDays(0)="DEMO"
         MapTex="p2misc_full.map_day4"
         NewsTex="p2misc_full.newspaper_day_4"
         DudeNewsComment="DudeDialog.dude_news_thursday"
         LoadTex="p2misc_full.loading4"
         DudeStartComment="DudeDialog.dude_map_exit4"
         Errands(0)=ErrandBase'AW7Game.ErrandBase11'
         Errands(1)=ErrandBase'AW7Game.ErrandBase12'
         Errands(2)=ErrandBase'AW7Game.ErrandBase13'
         Errands(3)=ErrandBase'AW7Game.ErrandBase14'
         PlayerInvList(0)=(InvClassName="Inventory.CitationInv")
         TakeFromPlayerList(0)=(InvClassName="Inventory.NewspaperInv")
         TakeFromPlayerList(1)=(InvClassName="Inventory.GimpClothesInv")
         TakeFromPlayerList(2)=(InvClassName="Inventory.DudeClothesInv")
         TakeFromPlayerList(3)=(InvClassName="Inventory.KrotchyInv")
         TakeFromPlayerList(4)=(InvClassName="Inventory.SteakInv")
         TakeFromPlayerList(5)=(InvClassName="Inventory.CitationInv")
         Name="DayBase62"
     End Object
     Days(3)=DayBase'AW7addinIG50Game.DayBase62'
     Begin Object Class=DayBase Name=DayBase63
         Description="Friday"
         UniqueName="7DAYE"
         ExcludeDays(0)="DEMO"
         MapTex="p2misc_full.map_day5"
         NewsTex="p2misc_full.newspaper_day_5"
         DudeNewsComment="DudeDialog.dude_news_friday"
         LoadTex="p2misc_full.loading5"
         DudeStartComment="DudeDialog.dude_map_exit5"
         Errands(0)=ErrandBase'AW7Game.ErrandBase15'
         Errands(1)=ErrandBase'AW7Game.ErrandBase16'
         Errands(2)=ErrandBase'AW7Game.ErrandBase17'
         Errands(3)=ErrandBase'AW7Game.ErrandBase18'
         PlayerInvList(0)=(InvClassName="Inventory.GiftInv")
         PlayerInvList(1)=(InvClassName="Inventory.GonorrheaAmmoInv")
         TakeFromPlayerList(0)=(InvClassName="Inventory.NewspaperInv")
         TakeFromPlayerList(1)=(InvClassName="Inventory.GimpClothesInv")
         TakeFromPlayerList(2)=(InvClassName="Inventory.DudeClothesInv")
         TakeFromPlayerList(3)=(InvClassName="Inventory.ParcelInv")
         TakeFromPlayerList(4)=(InvClassName="Inventory.AlternatorInv")
         TakeFromPlayerList(5)=(InvClassName="Inventory.PillsInv")
         TakeFromPlayerList(6)=(InvClassName="Inventory.GonorrheaAmmoInv")
         TakeFromPlayerList(7)=(InvClassName="Inventory.MapInv")
         TakeFromPlayerList(8)=(InvClassName="Inventory.GiftInv")
         Name="DayBase63"
     End Object
     Days(4)=DayBase'AW7addinIG50Game.DayBase63'
     Begin Object Class=DayBase Name=DayBase64
         Description="Saturday"
         UniqueName="DAY_A"
         ExcludeDays(0)="DEMO"
         LoadTex="aw_textures.loading_sat"
         DudeStartComment="DudeDialog.dude_map_exit1"
         Errands(0)=ErrandBase'AWGame.ErrandBase0'
         TakeFromPlayerList(0)=(InvClassName="Inventory.NewspaperInv")
         TakeFromPlayerList(1)=(InvClassName="Inventory.GimpClothesInv")
         TakeFromPlayerList(2)=(InvClassName="Inventory.DudeClothesInv")
         TakeFromPlayerList(3)=(InvClassName="Inventory.MapInv")
         Name="DayBase64"
     End Object
     Days(5)=DayBase'AW7addinIG50Game.DayBase64'
     Begin Object Class=DayBase Name=DayBase65
         Description="Sunday"
         UniqueName="DAY_B"
         ExcludeDays(0)="DEMO"
         LoadTex="aw_textures.loading_sun"
         DudeStartComment="DudeDialog.dude_map_exit1"
         Errands(0)=ErrandBase'AWGame.ErrandBase1'
         TakeFromPlayerList(0)=(InvClassName="Inventory.NewspaperInv")
         TakeFromPlayerList(1)=(InvClassName="Inventory.GimpClothesInv")
         TakeFromPlayerList(2)=(InvClassName="Inventory.DudeClothesInv")
         TakeFromPlayerList(3)=(InvClassName="Inventory.MapInv")
         Name="DayBase65"
     End Object
     Days(6)=DayBase'AW7addinIG50Game.DayBase65'
     IntroURL="AW7_WeekendIntro.fuk"
     MatSwaps(0)=(OrigMat=Texture'Josh-textures.signs.game_banner_2',NewMat=Texture'Josh-textures.signs.game_banner_5')
     MatSwaps(1)=(OrigMat=Texture'Timb.arcade.Game_FagHunter',NewMat=Texture'Timb.arcade.Game_BastardFish')
}
